## cppdb 0.3.1%2Bdfsg

=== debian/changelog ===
cppdb (0.3.1+dfsg-6) unstable; urgency=medium

  * Mark -dev-package Multiarch:Same
  * Bump S-V to 4.0.0 -- no changes required

 -- Tobias Frost <tobi@debian.org>  Sun, 09 Jul 2017 14:47:50 +0200

cppdb (0.3.1+dfsg-5) unstable; urgency=medium

  * Change B-D from libmysqlclient-dev to default-libmysqlclient-dev.
  * Bump d/compat level to 10
    - B-D on debhelper >10
    - remove --parallel from d/rules, it is default now

 -- Tobias Frost <tobi@debian.org>  Sat, 22 Oct 2016 19:41:37 +0200

cppdb (0.3.1+dfsg-4) unstable; urgency=medium

  * Bump S-V to 3.9.8 -- no changes required.
  * Replace VCS-Git git:// with https:// URL
  * Replace Homepage with a more informative one
  * Explicitly enable all hardening options

 -- Tobias Frost <tobi@debian.org>  Sun, 11 Sep 2016 13:17:43 +0200

cppdb (0.3.1+dfsg-3) unstable; urgency=medium

  * Upload to unstable.
  * Update years in d/copyright and change also to my Debian email.
  * Move license grants to the license paragraphs to avoid lintian warnings.

 -- Tobias Frost <tobi@debian.org>  Mon, 15 Jun 2015 14:07:21 +0200

cppdb (0.3.1+dfsg-2) experimental; urgency=medium

  * Move git repository to collab-maint (as gitorious will be discontinued).
  * Bump SV -- no changes.
  * Set maintainer to my Debian email.
  * Add license grant to d/copyright, do not install copyright.txt

 -- Tobias Frost <tobi@debian.org>  Wed, 11 Mar 2015 08:59:25 +0100

cppdb (0.3.1+dfsg-1) unstable; urgency=low

  * Initial release (Closes: #753013).

 -- Tobias Frost <tobi@coldtobi.de>  Fri, 01 Aug 2014 23:35:26 +0200

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
export DEB_LDFLAGS_MAINT_APPEND := -Wl,--as-needed

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- -DLIBDIR=lib/$(DEB_HOST_MULTIARCH) -DODBC_BACKEND_INTERNAL=OFF

## cppdb 0.3.1+dfsg

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6)
project(cppdb)

set(CPPDB_MAJOR 0)
set(CPPDB_MINOR 3)
set(CPPDB_PATCH 1)

set(CPPDB_VERSION ${CPPDB_MAJOR}.${CPPDB_MINOR}.${CPPDB_PATCH})
set(CPPDB_SOVERSION ${CPPDB_MAJOR})

add_definitions(
		-DCPPDB_MAJOR=${CPPDB_MAJOR}
		-DCPPDB_MINOR=${CPPDB_MINOR}
		-DCPPDB_PATCH=${CPPDB_PATCH}
		-DCPPDB_VERSION="${CPPDB_MAJOR}.${CPPDB_MINOR}.${CPPDB_PATCH}"
	)

option(DISABLE_SQLITE	"Link sqlite3 backend into the libcppdb" OFF)
option(DISABLE_PQ 	"Link postgresql backend into the libcppdb" OFF)
option(DISABLE_MYSQL	"Link mysql backend into the libcppdb" OFF)
option(DISABLE_ODBC	"Link odbc backend into the libcppdb" OFF)


option(SQLITE_BACKEND_INTERNAL	"Link sqlite3 backend into the libcppdb" OFF)
option(PQ_BACKEND_INTERNAL 	"Link postgresql backend into the libcppdb" OFF)
option(MYSQL_BACKEND_INTERNAL	"Link mysql backend into the libcppdb" OFF)
option(ODBC_BACKEND_INTERNAL	"Link odbc backend into the libcppdb" ON)

if(NOT LIBDIR)
	set(LIBDIR lib CACHE STRING "Library installation directory" FORCE)
endif()




# General settings

include_directories(.)

add_definitions(-DCPPDB_LIBRARY_PREFIX="${CMAKE_SHARED_LIBRARY_PREFIX}")
add_definitions(-DCPPDB_LIBRARY_SUFFIX="${CMAKE_SHARED_LIBRARY_SUFFIX}")
add_definitions(-DCPPDB_SOVERSION="${CPPDB_SOVERSION}")

# Basic common configuration

if(NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE RelWithDebInfo CACHE STRING
        "Choose the type of build, options are: None Debug Release RelWithDebInfo MinSizeRel."
	      FORCE)
endif(NOT CMAKE_BUILD_TYPE)


include(CheckLibraryExists)
include(CheckCXXSourceCompiles)

if(NOT WIN32)
	find_library(DL_LIB dl)
	find_library(PTHREAD_LIB pthread NAMES thr kse)
endif()

if(CMAKE_COMPILER_IS_GNUCXX)
	set(CXX_FLAGS "-Wall -Wextra")
	if(CMAKE_SYSTEM_NAME STREQUAL "SunOS")
		set(CXX_FLAGS "${CXX_FLAGS} -pthreads")
	endif()
elseif(CMAKE_CXX_COMPILER_ID STREQUAL "Intel")
	set(CXX_FLAGS "-Wall")
elseif(MSVC)
	set(CXX_FLAGS "/EHsc /W3")
elseif(CMAKE_CXX_COMPILER_ID STREQUAL "SunPro")
	if(CMAKE_SYSTEM_NAME STREQUAL "SunOS")
		set(CXX_FLAGS "${CXX_FLAGS} -mt")
	endif()
endif()

set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${CXX_FLAGS}")


check_cxx_source_compiles(
	"int main() { volatile int v=0; return __sync_bool_compare_and_swap(&v,0,1); }"
	CPPDB_HAS_GCC_SYNC)
if(CPPDB_HAS_GCC_SYNC)
	add_definitions(-DCPPDB_HAS_GCC_SYNC)
endif()

check_cxx_source_compiles(
	"#include <bits/atomicity.h> 
	using __gnu_cxx::__exchange_and_add;
	int main(){ volatile int x=0; return __exchange_and_add(&x,1);}"
	CPPDB_HAVE_GCC_BITS_EXCHANGE_AND_ADD)
if(CPPDB_HAVE_GCC_BITS_EXCHANGE_AND_ADD)
	add_definitions(-DCPPDB_HAVE_GCC_BITS_EXCHANGE_AND_ADD)
endif()

check_cxx_source_compiles(
	"#include <ext/atomicity.h> 
	using __gnu_cxx::__exchange_and_add;
	int main(){ volatile int x=0; return __exchange_and_add(&x,1);}"
	CPPDB_HAVE_GCC_EXT_EXCHANGE_AND_ADD)
if(CPPDB_HAVE_GCC_EXT_EXCHANGE_AND_ADD)
	add_definitions(-DCPPDB_HAVE_GCC_EXT_EXCHANGE_AND_ADD)
endif()

check_cxx_source_compiles(
	"#include <sys/types.h>
	#include <machine/atomic.h>
	int main() { volatile unsigned v=0; return atomic_cmpset_int(&v,1,0); }"
	CPPDB_HAVE_FREEBSD_ATOMIC)

if(CPPDB_HAVE_FREEBSD_ATOMIC)
	add_definitions(-DCPPDB_HAVE_FREEBSD_ATOMIC)
endif()

check_cxx_source_compiles(
	"#include <atomic.h>
	int main() { volatile unsigned v=0; return atomic_add_int_nv(&v,1); }"
	CPPDB_HAVE_SOLARIS_ATOMIC)
if(CPPDB_HAVE_SOLARIS_ATOMIC)
	add_definitions(-DCPPDB_HAVE_SOLARIS_ATOMIC)
endif()


check_cxx_source_compiles(
	"#include <libkern/OSAtomic.h>
	int main() { volatile int v=0; return OSAtomicAdd32(1,&v); }"
	CPPDB_HAVE_MAC_OS_X_ATOMIC)

if(CPPDB_HAVE_MAC_OS_X_ATOMIC)
	add_definitions(-DCPPDB_HAVE_MAC_OS_X_ATOMIC)
endif()

# Backend configuration

set(INTERNAL_SOURCES)
set(INTERNAL_LIBRARIES)
set(BACKEND_LIBRARIES)

if(NOT DISABLE_ODBC)
	find_library(ODBC_LIB odbc NAMES odbc32)
	find_path(ODBC_PATH sqlext.h)
	if(ODBC_LIB AND ODBC_PATH)
		include_directories(${ODBC_PATH})
		if(ODBC_BACKEND_INTERNAL)
			set(INTERNAL_SOURCES ${INTERNAL_SOURCES} drivers/odbc_backend.cpp)
			set(INTERNAL_LIBRARIES ${INTERNAL_LIBRARIES} ${ODBC_LIB})
			add_definitions(-DCPPDB_WITH_ODBC)
		else()
			add_library(cppdb_odbc SHARED drivers/odbc_backend.cpp)
			target_link_libraries(cppdb_odbc ${ODBC_LIB})
			add_library(cppdb_odbc-static STATIC drivers/odbc_backend.cpp)
			set(BACKEND_LIBRARIES ${BACKEND_LIBRARIES} cppdb_odbc)
		endif()
	else()
		message("-- odbc library was not found, disabling odbc backend")
	endif()
endif()

if(NOT DISABLE_SQLITE)
	find_library(SQLITE3_LIB sqlite3)
	find_path(SQLITE3_PATH sqlite3.h)
	if(SQLITE3_LIB AND SQLITE3_PATH)
		include_directories(${SQLITE3_PATH})
		if(SQLITE_BACKEND_INTERNAL)
			add_definitions(-DCPPDB_WITH_SQLITE3)
			set(INTERNAL_SOURCES ${INTERNAL_SOURCES} drivers/sqlite3_backend.cpp)
			set(INTERNAL_LIBRARIES ${INTERNAL_LIBRARIES} ${SQLITE3_LIB})
		else()
			add_library(cppdb_sqlite3 SHARED drivers/sqlite3_backend.cpp)
			target_link_libraries(cppdb_sqlite3 ${SQLITE3_LIB})
			add_library(cppdb_sqlite3-static STATIC drivers/sqlite3_backend.cpp)
			set(BACKEND_LIBRARIES ${BACKEND_LIBRARIES} cppdb_sqlite3)
		endif()
	else()
		message("-- sqlite3 library was not found, disabling sqlite3 backend")
	endif()
endif()

if(NOT DISABLE_PQ)
	find_library(PQ_LIB pq)
	find_path(PQ_PATH libpq-fe.h PATH_SUFFIXES postgresql pgsql)
	if(PQ_LIB AND PQ_PATH)
		include_directories(${PQ_PATH})
		if(PQ_BACKEND_INTERNAL)
			set(INTERNAL_SOURCES ${INTERNAL_SOURCES} drivers/postgres_backend.cpp)
			set(INTERNAL_LIBRARIES ${INTERNAL_LIBRARIES} ${PQ_LIB})
			add_definitions(-DCPPDB_WITH_PQ)
		else()
			add_library(cppdb_postgresql SHARED drivers/postgres_backend.cpp)
			add_library(cppdb_postgresql-static STATIC drivers/postgres_backend.cpp)
			target_link_libraries(cppdb_postgresql ${PQ_LIB})
			set(BACKEND_LIBRARIES ${BACKEND_LIBRARIES} cppdb_postgresql)
		endif()
	else()
		message("-- libpq not found, disableing postgresql backend")
	endif()
endif()

if(NOT DISABLE_MYSQL)
	find_library(MYSQL_LIB mysqlclient)
	find_path(MYSQL_PATH mysql.h PATH_SUFFIXES mysql)
	if(MYSQL_LIB AND MYSQL_PATH)
		include_directories(${MYSQL_PATH})
		if(MYSQL_BACKEND_INTERNAL)
			set(INTERNAL_SOURCES ${INTERNAL_SOURCES} drivers/mysql_backend.cpp)
			set(INTERNAL_LIBRARIES ${INTERNAL_LIBRARIES} ${MYSQL_LIB})
			add_definitions(-DCPPDB_WITH_MYSQL)
		else()
			add_library(cppdb_mysql SHARED drivers/mysql_backend.cpp)
			add_library(cppdb_mysql-static STATIC drivers/mysql_backend.cpp)
			target_link_libraries(cppdb_mysql ${MYSQL_LIB})
			set(BACKEND_LIBRARIES ${BACKEND_LIBRARIES} cppdb_mysql)
		endif()
	else()
		message("-- mysqlclient not found, disableing mysql backend")
	endif()
endif()


# Main library configuration

set(CPPDB_SRC
	src/utils.cpp
	src/mutex.cpp
	src/driver_manager.cpp
	src/conn_manager.cpp
	src/shared_object.cpp
	src/pool.cpp
	src/backend.cpp
	src/frontend.cpp
	src/atomic_counter.cpp
	${INTERNAL_SOURCES}
	)

add_library(cppdb SHARED ${CPPDB_SRC})
add_library(cppdb-static STATIC ${CPPDB_SRC})
set_target_properties(cppdb PROPERTIES COMPILE_DEFINITIONS CPPDB_EXPORTS)

if(NOT WIN32)
	if(DL_LIB)
		target_link_libraries(cppdb ${DL_LIB})
	endif()
	target_link_libraries(cppdb ${PTHREAD_LIB})
endif()

# Link and backends configuration

set(INST_LIBS)



foreach(LIB ${BACKEND_LIBRARIES} cppdb)
	
	set(INST_LIBS ${INST_LIBS} ${LIB} ${LIB}-static)

	if(WIN32)
		set_target_properties(${LIB} PROPERTIES VERSION ${CPPDB_SOVERSION} SOVERSION ${CPPDB_SOVERSION})
	else()
		set_target_properties(${LIB} PROPERTIES VERSION ${CPPDB_VERSION} SOVERSION ${CPPDB_SOVERSION})
	endif()

    
	set_target_properties(${LIB} PROPERTIES CLEAN_DIRECT_OUTPUT 1)
	set_target_properties(${LIB} PROPERTIES OUTPUT_NAME "${LIB}")
	set_target_properties(${LIB}-static PROPERTIES CLEAN_DIRECT_OUTPUT 1)
	set_target_properties(${LIB}-static PROPERTIES OUTPUT_NAME "${LIB}")
	set_target_properties(${LIB}-static PROPERTIES PREFIX "lib") # Make sure import and normal library do not collide

 endforeach()

foreach(LIB ${BACKEND_LIBRARIES})
	set_target_properties(${LIB} PROPERTIES COMPILE_DEFINITIONS CPPDB_DRIVER_EXPORTS)
	target_link_libraries(${LIB} cppdb)
endforeach()

foreach(LIB ${INTERNAL_LIBRARIES})
	target_link_libraries(cppdb ${LIB})
endforeach()

# tests

add_executable(test_perf test/test_perf.cpp)
add_executable(test_basic test/test_basic.cpp)
add_executable(test_backend test/test_backend.cpp)
add_executable(test_caching test/test_caching.cpp)
add_executable(example examples/example1.cpp)

set_target_properties(	test_perf test_backend test_basic test_caching example 
			PROPERTIES 
				COMPILE_DEFINITIONS CPPDB_EXPORTS)

target_link_libraries(test_perf cppdb)
target_link_libraries(test_basic cppdb)
target_link_libraries(test_backend cppdb)
target_link_libraries(test_caching cppdb)
target_link_libraries(example cppdb)

install(TARGETS ${INST_LIBS} 
	RUNTIME DESTINATION bin
	LIBRARY DESTINATION ${LIBDIR}
	ARCHIVE DESTINATION ${LIBDIR}
	PUBLIC_HEADER DESTINATION include/cppdb)

install(DIRECTORY cppdb DESTINATION include
        PATTERN ".svn" EXCLUDE)

=== debian/changelog ===
cppdb (0.3.1+dfsg-9) unstable; urgency=medium

  [ Ondřej Nový ]
  * d/watch: Use https protocol

  [ Debian Janitor ]
  * Bump debhelper from old 11 to 12.
  * Set debhelper-compat version in Build-Depends.
  * Set upstream metadata fields: Archive, Repository.
  * Update standards version to 4.2.1, no changes needed.

  [ Tobias Frost ]
  * Enable CI on salsa.
  * Fix field name case in debian/control. (VCS-* => Vcs-*)
  * Fix linitan error description-contains-invalid-control-statement, as
    there was an extra space.
  * Bump compat level to 13 -- no changes.
  * Bump S-V to 4.6.0 -- no changes required.
  * Bump d/watch to version 4.
  * Drop -Wl,--as-needed linker flags, they are default now.

 -- Tobias Frost <tobi@debian.org>  Tue, 19 Oct 2021 16:21:37 +0200

cppdb (0.3.1+dfsg-8) unstable; urgency=medium

  * Drop the symbols files again. It is just not sustainable.
    (Closes: #906456)
  * Adding lintian overrides for the missing symbol files.
  * Bump S-V to 4.2.0 (adding Rules-Requires-Root)

 -- Tobias Frost <tobi@debian.org>  Thu, 23 Aug 2018 19:55:38 +0200

cppdb (0.3.1+dfsg-7) unstable; urgency=medium

  * Upload to unstable.

 -- Tobias Frost <tobi@debian.org>  Sat, 05 May 2018 09:53:47 +0200

cppdb (0.3.1+dfsg-7~exp6) experimental; urgency=medium

  * Fix typo in symbols file.

 -- Tobias Frost <tobi@debian.org>  Sat, 14 Apr 2018 11:17:54 +0200

cppdb (0.3.1+dfsg-7~exp5) experimental; urgency=medium

  * Another try on symbols, should hopefully fix them for ppc64el and powerpc.

 -- Tobias Frost <tobi@debian.org>  Sat, 14 Apr 2018 08:39:44 +0200

cppdb (0.3.1+dfsg-7~exp4) experimental; urgency=medium

  * Really drop pkg-kde-tools from B-D.
    (it had been removed from d/rules, but not from d/control)
  * Temporarily (as experimental) build B-D on debhelper 11.2.1
    as it fixes the cmake problem.

 -- Tobias Frost <tobi@debian.org>  Sun, 08 Apr 2018 11:34:30 +0200

cppdb (0.3.1+dfsg-7~exp3) experimental; urgency=medium

  * Drop pkg-kde-tools from B-D

 -- Tobias Frost <tobi@debian.org>  Sun, 08 Apr 2018 01:06:33 +0200

cppdb (0.3.1+dfsg-7~exp2) experimental; urgency=medium

  * Working on symbols files -- failed as expected.
    Trying again with pkg-kde-tools

 -- Tobias Frost <tobi@debian.org>  Sat, 07 Apr 2018 23:36:06 +0200

cppdb (0.3.1+dfsg-7~exp1) experimental; urgency=medium

  * Upload to experimental because for test-compile to
    get symbols for all archs.
  * Move repository to salsa.d.o.
  * Update meta-data from the patch.
  * Bump compat level to 11 and B-D on debhelper >= 11.
  * Bump S-V to 4.1.3:
    * The change that get-orig-source is depreciated makes
      README.Source obsolete, thus removed.
    * Moved the reason for repacking to d/copyright
  * Updated copyright years and switch to https:// links where possible.
  * Remove lintian overrides to give symbol files another try.
  * Also package the example in the -dev package.

 -- Tobias Frost <tobi@debian.org>  Thu, 05 Apr 2018 22:27:59 +0200

=== debian/control ===
Source: cppdb
Priority: optional
Maintainer: Tobias Frost <tobi@debian.org>
Build-Depends: cmake,
               debhelper-compat (= 13),
               default-libmysqlclient-dev,
               libpq-dev,
               libsqlite3-dev,
               unixodbc-dev
Rules-Requires-Root: no
Standards-Version: 4.6.0
Section: libs
Homepage: http://cppcms.com/wikipp/en/page/sql_connectivity
Vcs-Git: https://salsa.debian.org/debian/cppdb.git
Vcs-Browser: https://salsa.debian.org/debian/cppdb

Package: libcppdb-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libcppdb-mysql0 (= ${binary:Version}),
         libcppdb-odbc0 (= ${binary:Version}),
         libcppdb-postgresql0 (= ${binary:Version}),
         libcppdb-sqlite3-0 (= ${binary:Version}),
         libcppdb0 (= ${binary:Version}),
         ${misc:Depends}
Description: SQL Connectivity Library (development files)
 CppDB is an SQL connectivity library that is designed to provide platform and
 Database independent connectivity API similarly to what JDBC, ODBC and other
 connectivity libraries do.
 .
 This library is developed as part of CppCMS Project - the C++ Web Development
 Framework.
 .
 CppDB was designed with following goals in the mind:
  - Performance is the primary goal - make fastest possible SQL connectivity as
    possible
  - Transparent connection pooling support
  - Transparent prepared statements caching
  - Dynamic DB modules loading and optional static linking
  - Full and high priority support of FOSS RDBMS: MySQL, PostgreSQL, Sqlite3
  - Support as many RDBMSs as possible via cppdb-odbc bridge
  - Simplicity in use
  - Locale safety
  - Support of both explicit verbose API and brief and nice syntactic sugar
 .
 This package contains the development files.

Package: libcppdb0
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Suggests: libcppdb-mysql0,
          libcppdb-odbc0,
          libcppdb-postgresql0,
          libcppdb-sqlite3-0
Description: SQL Connectivity Library (core library)
 CppDB is an SQL connectivity library that is designed to provide platform and
 Database independent connectivity API similarly to what JDBC, ODBC and other
 connectivity libraries do.
 .
 This library is developed as part of CppCMS Project - the C++ Web Development
 Framework.
 .
 CppDB was designed with following goals in the mind:
  - Performance is the primary goal - make fastest possible SQL connectivity as
    possible
  - Transparent connection pooling support
  - Transparent prepared statements caching
  - Dynamic DB modules loading and optional static linking
  - Full and high priority support of FOSS RDBMS: MySQL, PostgreSQL, Sqlite3
  - Support as many RDBMSs as possible via cppdb-odbc bridge
  - Simplicity in use
  - Locale safety
  - Support of both explicit verbose API and brief and nice syntactic sugar
 .
 This package contains the core library

Package: libcppdb-mysql0
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: SQL Connectivity Library (MySQL backend)
 CppDB is an SQL connectivity library that is designed to provide platform and
 Database independent connectivity API similarly to what JDBC, ODBC and other
 connectivity libraries do.
 .
 This library is developed as part of CppCMS Project - the C++ Web Development
 Framework.
 .
 CppDB was designed with following goals in the mind:
  - Performance is the primary goal - make fastest possible SQL connectivity as
    possible
  - Transparent connection pooling support
  - Transparent prepared statements caching
  - Dynamic DB modules loading and optional static linking
  - Full and high priority support of FOSS RDBMS: MySQL, PostgreSQL, Sqlite3
  - Support as many RDBMSs as possible via cppdb-odbc bridge
  - Simplicity in use
  - Locale safety
  - Support of both explicit verbose API and brief and nice syntactic sugar
 .
 This package contains the MySQL backend

Package: libcppdb-sqlite3-0
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: SQL Connectivity Library (sqlite3 backend)
 CppDB is an SQL connectivity library that is designed to provide platform and
 Database independent connectivity API similarly to what JDBC, ODBC and other
 connectivity libraries do.
 .
 This library is developed as part of CppCMS Project - the C++ Web Development
 Framework.
 .
 CppDB was designed with following goals in the mind:
  - Performance is the primary goal - make fastest possible SQL connectivity as
    possible
  - Transparent connection pooling support
  - Transparent prepared statements caching
  - Dynamic DB modules loading and optional static linking
  - Full and high priority support of FOSS RDBMS: MySQL, PostgreSQL, Sqlite3
  - Support as many RDBMSs as possible via cppdb-odbc bridge
  - Simplicity in use
  - Locale safety
  - Support of both explicit verbose API and brief and nice syntactic sugar
 .
 This package contains the sqlite3 backend

Package: libcppdb-postgresql0
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: SQL Connectivity Library (PostgreSQL backend)
 CppDB is an SQL connectivity library that is designed to provide platform and
 Database independent connectivity API similarly to what JDBC, ODBC and other
 connectivity libraries do.
 .
 This library is developed as part of CppCMS Project - the C++ Web Development
 Framework.
 .
 CppDB was designed with following goals in the mind:
  - Performance is the primary goal - make fastest possible SQL connectivity as
    possible
  - Transparent connection pooling support
  - Transparent prepared statements caching
  - Dynamic DB modules loading and optional static linking
  - Full and high priority support of FOSS RDBMS: MySQL, PostgreSQL, Sqlite3
  - Support as many RDBMSs as possible via cppdb-odbc bridge
  - Simplicity in use
  - Locale safety
  - Support of both explicit verbose API and brief and nice syntactic sugar
 .
 This package contains the PostgreSQL backend

Package: libcppdb-odbc0
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: SQL Connectivity Library (odbc backend)
 CppDB is an SQL connectivity library that is designed to provide platform and
 Database independent connectivity API similarly to what JDBC, ODBC and other
 connectivity libraries do.
 .
 This library is developed as part of CppCMS Project - the C++ Web Development
 Framework.
 .
 CppDB was designed with following goals in the mind:
  - Performance is the primary goal - make fastest possible SQL connectivity as
    possible
  - Transparent connection pooling support
  - Transparent prepared statements caching
  - Dynamic DB modules loading and optional static linking
  - Full and high priority support of FOSS RDBMS: MySQL, PostgreSQL, Sqlite3
  - Support as many RDBMSs as possible via cppdb-odbc bridge
  - Simplicity in use
  - Locale safety
  - Support of both explicit verbose API and brief and nice syntactic sugar
 .
 This package contains the odbc backend

=== debian/rules ===
--- 
+++ 
@@ -6,11 +6,9 @@
 
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
 export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
-export DEB_LDFLAGS_MAINT_APPEND := -Wl,--as-needed
 
 %:
 	dh $@
 
 override_dh_auto_configure:
 	dh_auto_configure -- -DLIBDIR=lib/$(DEB_HOST_MULTIARCH) -DODBC_BACKEND_INTERNAL=OFF
-

=== debian/watch ===
version=4
opts=dversionmangle=s/\+dfsg(\.\d+)?$// \
https://sf.net/cppcms/cppdb-(.*)\.(?:zip|tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))
